#include <stdio.h>
#include <stdint.h>
#include <errno.h>
#include <malloc.h>

//filenames only.  no boundary checking.  final destination.
int main (int argc, char *argv[]){
uint32_t current_loc = 0;
uint8_t curbyte = 0;
uint8_t outbits = 0;
char *file_out;
FILE *filepointer;

//uint32_t filesize = atol (argv[3]);

uint32_t filesize;

filepointer = fopen (argv[1],"r");
if (filepointer==NULL){return 2;}

fseek(filepointer, 0, SEEK_END); 
filesize = ftell(filepointer);//get end position for the size value
fseek(filepointer, 0, SEEK_SET);//reset counter so fgetc doesn't bail out
file_out = malloc(filesize);


for (current_loc = 0; current_loc < filesize;current_loc++){
		curbyte = fgetc(filepointer);
		outbits = curbyte & 0x77; //Get the lowest three bits in each nibble
		curbyte = curbyte - outbits;//Remove the lowest three bits from each nibble from curbyte so we can add them back later, modified.
		outbits = ~outbits;//Invert the lowest three bits from each nibble by flipping the whole number
		outbits = outbits & 0x77;//toss out all the unrelated bits we accidentally flipped
		curbyte = curbyte + outbits;
		file_out[current_loc] = curbyte;
		//printf ("%c",curbyte);
		}

fclose (filepointer);		
filepointer = fopen (argv[2],"w");
fwrite (file_out,1,filesize,filepointer);

free(file_out);

return 0;
}
